*+
*+
*+    Source Module => D:\SRC\CLICK\FUNCTRAK.PRG
*+
*+    Click! is a Clipper/Xbase++ source code reformatter.
*+    
*+    Copyright(C) 1996-1999 by Phil Barnett.
*+       
*+    This program is free software; you can redistribute it and/or modify it
*+    under the terms of the GNU General Public License as published by the
*+    Free Software Foundation; either version 2 of the License, or (at your
*+    option) any later version.
*+    
*+    This program is distributed in the hope that it will be useful, but
*+    WITHOUT ANY WARRANTY; without even the implied warranty of
*+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*+    General Public License for more details.
*+    
*+    You should have received a copy of the GNU General Public License along
*+    with this program; if not, write to the Free Software Foundation, Inc.,
*+    675 Mass Ave, Cambridge, MA 02139, USA.
*+    
*+    You can contact me at:
*+    
*+    Phil Barnett
*+    Box 944
*+    Plymouth, Florida  32768
*+    
*+    or
*+    
*+    philb@iag.net
*+
*+    Functions: Procedure init_func_text()
*+               Procedure functrak()
*+               Procedure func_call()
*+               Procedure end_func_text()
*+               Procedure func_text()
*+               Static Function findfunc()
*+               Static Function SubArrySrch()
*+
*+    Reformatted by Click! 2.03 on Jan-26-1999 at 12:35 am
*+
*+

static aFuncs     := {}                 // List of functions in each module
static aThisSrc   := {}                 // Module Name, sub function list
static aFuncList  := {}                 // The big collection of how each function gets called
static aTable     := {}                 // contains table references for the TABLE.TXT file
static aIndex     := {}                 // contains index references for the INDEX.TXT file
static sFuncText  := ''                 // contains the function header line
static sModule    := ''                 // contains the current module name
static cFullPath  := ''                 // contains a reference to the
static aMyLibFunc := {}                 // static array of table function names
static aMyIndFunc := {}                 // static array of index function names

*+
*+
*+    Procedure init_func_text()
*+
*+    Called from ( click.prg    )   1 - procedure click()
*+
*+
*+
procedure init_func_text( cModule )

// called at the beginning of each file

local cMyLibFunc
local cMyIndFunc
local nElems
local x

if cFullPath == ''
   cFullPath  := if( file( 'CLICK.INI' ), 'CLICK', rootname( ft_origin() ) ) + '.INI'
   cMyLibFunc := upper( ProfileString( cFullPath, 'CLICK', 'MY_TABLE_FUNCTION', '' ) )
   cMyIndFunc := upper( ProfileString( cFullPath, 'CLICK', 'MY_INDEX_FUNCTION', '' ) )
   if !empty( cMyLibFunc )
      nElems := numtoken( cMyLibFunc, '|' )
      asize( aMyLibFunc, nElems )
      for x := 1 to nElems
         aMyLibFunc[ x ] := upper( token( cMyLibFunc, '|', x ) )
      next
      // add this to the array
      aadd( aMyLibFunc, 'DBUSEAREA' )
   endif
   if !empty( cMyIndFunc )
      nElems := numtoken( cMyIndFunc, '|' )
      asize( aMyIndFunc, nElems )
      for x := 1 to nElems
         aMyIndFunc[ x ] := upper( token( cMyIndFunc, '|', x ) )
      next
      // add this to the array
      aadd( aMyIndFunc, 'DBCREATEIND' )
   endif
endif

sModule := cModule

return

*+
*+
*+    Procedure functrak()
*+
*+    Called from ( click.prg    )   1 - static function func_head()
*+
*+
*+
procedure functrak( cFuncText )

// Called as each function header is created

sFuncText := cFuncText

if empty( aThisSrc )
   aThisSrc := { sModule, {} }
endif

aadd( aThisSrc[ 2 ], sFuncText )

return

*+
*+
*+    Procedure func_call()
*+
*+    Called from ( click.prg    )   1 - procedure click()
*+
*+
*+
procedure func_call( aLine, aType )

// called as each line is parsed.

local x
local nHowmany  := len( aType )
local nPointer
local nPointer2
local uFW       := upper( aLine[ 1 ] )
local cLine     := ''

for x := 1 to nHowMany
   if aType[ x ] == 'F'
      nPointer := ascan( aFuncList, { | y | upper( y[ 1 ] ) == upper( aLine[ x ] ) } )
      if empty( nPointer )
         aadd( afunclist, { aLine[ x ], { { sFuncText, sModule, 1 } } } )
      else
         if ( nPointer2 := ascan( aFuncList[ nPointer, 2 ], { | y | y[ 1 ] == sFuncText .and. y[ 2 ] == sModule } ) ) == 0
            aadd( afunclist[ nPointer, 2 ], { sFuncText, sModule, 1 } )
         else
            aFuncList[ nPointer, 2, nPointer2, 3 ] ++
         endif
      endif
   endif
next

// this collects TABLE and INDEX information

do case
case uFW == 'USE' .or. SubArrySrch( aMyLibFunc, aLine )

   for x := 1 to nHowMany
      cLine += aLine[ x ]
   next

   nPointer := ascan( aTable, { | y | y[ 1 ] == sModule } )

   if empty( nPointer )
      aadd( aTable, { sModule, { { sFuncText, cLine, 1 } } } )
   else
      if ( nPointer2 := ascan( aTable[ nPointer, 2 ], { | y | y[ 1 ] == sFuncText .and. upper( y[ 2 ] ) == upper( cLine ) } ) ) == 0
         aadd( aTable[ nPointer, 2 ], { sFuncText, cLine, 1 } )
      else
         aTable[ nPointer, 2, nPointer2, 3 ] ++
      endif
   endif

case uFW == 'INDEX' .or. SubArrySrch( aMyIndFunc, aLine )

   for x := 1 to nHowMany
      cLine += aLine[ x ]
   next

   nPointer := ascan( aIndex, { | y | y[ 1 ] == sModule } )

   if empty( nPointer )
      aadd( aIndex, { sModule, { { sFuncText, cLine, 1 } } } )
   else
      if ( nPointer2 := ascan( aIndex[ nPointer, 2 ], { | y | y[ 1 ] == sFuncText .and. upper( y[ 2 ] ) == upper( cLine ) } ) ) == 0
         aadd( aIndex[ nPointer, 2 ], { sFuncText, cLine, 1 } )
      else
         aIndex[ nPointer, 2, nPointer2, 3 ] ++
      endif
   endif

endcase

return

*+
*+
*+    Procedure end_func_text()
*+
*+    Called from ( click.prg    )   1 - procedure click()
*+
*+
*+
procedure end_func_text()

// called at the end of each file

if !empty( aThisSrc )
   aadd( aFuncs, aThisSrc )
   aThisSrc := {}
endif

return

*+
*+
*+    Procedure func_text()
*+
*+    Called from ( click.prg    )   1 - procedure click()
*+
*+
*+
procedure func_text( aLibList, aFileList )

// called after all files have been processed

// Pass 4, with the purple progress meter.

local cFullPath := if( file( 'CLICK.INI' ), 'CLICK', rootname( ft_origin() ) ) + '.INI'
local cOutDir   := ProfileString( cFullPath, 'CLICK', 'OUTPUT_DIRECTORY', 'CLICKOUT' )
local cSrcOut   := ProfileString( cFullPath, 'CLICK', 'SOURCE_XREF_FILE', 'SRC_CROS.TXT' )
local cFncOut   := ProfileString( cFullPath, 'CLICK', 'FUNCTION_XREF_FILE', 'FNC_CROS.TXT' )
local cTblOut   := ProfileString( cFullPath, 'CLICK', 'TABLE_XREF_FILE', 'TBL_CROS.TXT' )
local lSrcAdd   := ProfileString( cFullPath, 'CLICK', 'FUNCTION_REF_INTO_SOURCE', 'YES' ) == 'YES'
local lFncAdd   := ProfileString( cFullPath, 'CLICK', 'FUNCTION_XREF_INTO_SOURCE', 'YES' ) == 'YES'
local lTblAdd   := ProfileString( cFullPath, 'CLICK', 'TABLE_XREF_INTO_SOURCE', 'YES' ) == 'YES'
local lIndAdd   := ProfileString( cFullPath, 'CLICK', 'INDEX_XREF_INTO_SOURCE', 'YES' ) == 'YES'
local lTimeDate := ProfileString( cFullPath, 'CLICK', 'RETAIN_ORIGINAL_TIME_DATE_ON_OUTPUT_FILES', 'YES' ) == 'YES'
local cHeadDiv  := ProfileString( cFullPath, 'CLICK', 'HEAD_DIV', '' )

local bo_Handle
local bi_Handle
local CRLF         := chr( 13 ) + chr( 10 )
local cOutput
local cThisOut
local v
local w
local x
local y
local z
local cFoundIn
local nV
local nW
local nX
local nY
local cThisProg
local cLastProg
local cProg
local cThisFile
local cOutFile
local lGotHeader
local cThisLine
local cThisFunc
local spat
local nOldPcntDone
local nPcntDone    := 0
local lStatic
local lNoLibList   := empty( aLibList )
local lGotIt
local cLookFor
local aLib         := {}
local aHit         := {}
local nPointer
local nPointer1
local nPointer2
local nMinPntr
local aF2F         := {}
local aTemp        := {}

if lSrcAdd .or. lFncAdd .or. lTblAdd .or. lIndAdd

   // make copy for Function calls function pass
   aTemp := aclone( aFuncList )

   nX := len( atemp )

   for x := 1 to nX
      altd()
      y := atemp[ x ]
   next

   nV := len( aFilelist )
   for v := 1 to nV

      cThisFile := cOutDir + '\' + aFileList[ v ]
      show_out( cThisFile )
      cOutFile := cOutDir + '\' + '$tempfil.$$$'

      @  4,  1 clear to 4, maxcol() - 1
      centertext( 'Current File => ' + cThisFile, 4 )
      @  6, 11 clear to 6, maxcol() - 5
      @  6, 10 say '4'         

      // initialize buffered input and output

      bo_handle := bo_init( cOutFile )
      bi_handle := binit( cThisFile )

      bOpen( bi_handle )
      bo_Open( bo_handle )

      lGotHeader   := .f.
      nOldPcntDone := 0
      do while !beof( bi_handle )

         nOldPcntDone := nPcntDone
         nPcntDone    := int( bRelative( bi_handle ) * 50 )
         if nOldPcntDone <> nPcntDone
            @  6, 15 say replicate( '', nPcntDone ) color 'RB+/B'        
         endif

         cThisLine := bReadLine( bi_handle )

         if left( cThisLine, 2 ) == '*+'

            do case
            case left( cThisLine, 27 ) == '*+    Reformatted by Click!'

               // This inserts function data into the FILE HEADER.

               lGotHeader := .t.

               if lSrcAdd
                  w := ascan( aFuncs, { | x | x[ 1 ] == aFileList[ v ] } )
                  if w > 0
                     nY := len( aFuncs[ w, 2 ] )
                     if nY > 0
                        for y := 1 to nY
                           if y == 1
                              bo_write( bo_handle, '*+    Functions: ' + aFuncs[ w, 2, y ] + CRLF )
                           else
                              bo_write( bo_handle, '*+               ' + aFuncs[ w, 2, y ] + CRLF )
                           endif
                        next
                        bo_write( bo_handle, '*+' + CRLF )
                     endif
                  endif
               endif

               // This inserts table data into the FILE HEADER.

               if lTblAdd
                  if ( nPointer := ascan( aTable, { | x | x[ 1 ] == aFileList[ v ] } ) ) > 0
                     nY := len( aTable[ nPointer, 2 ] )
                     if lTblAdd .and. nY > 0
                        for y := 1 to nY
                           if y == 1
                              bo_write( bo_handle, '*+       Tables: ' + aTable[ nPointer, 2, y, 2 ] + CRLF )
                           else
                              bo_write( bo_handle, '*+               ' + aTable[ nPointer, 2, y, 2 ] + CRLF )
                           endif
                        next
                        bo_write( bo_handle, '*+' + CRLF )
                     endif
                  endif
               endif

               // This inserts index data into the FILE HEADER.

               if lIndAdd
                  if ( nPointer := ascan( aIndex, { | x | x[ 1 ] == aFileList[ v ] } ) ) > 0
                     nY := len( aIndex[ nPointer, 2 ] )
                     if lTblAdd .and. nY > 0
                        for y := 1 to nY
                           if y == 1
                              bo_write( bo_handle, '*+      Indexes: ' + aIndex[ nPointer, 2, y, 2 ] + CRLF )
                           else
                              bo_write( bo_handle, '*+               ' + aIndex[ nPointer, 2, y, 2 ] + CRLF )
                           endif
                        next
                        bo_write( bo_handle, '*+' + CRLF )
                     endif
                  endif
               endif

            case lFncAdd .and. lGotHeader .and. left( cThisLine, 6 ) == '*+    '

               // This inserts function data into the FUNCTION HEADERS

               cThisFunc := upper( substr( cThisLine, 7 ) )
               lStatic   := upper( left( cThisFunc, 4 ) ) == 'STAT'
               spat      := rat( ' ', cThisFunc )
               cThisFunc := substr( cThisFunc, spat + 1 )
               cThisFunc := left( cThisFunc, len( cThisFunc ) - 2 )

               x := ascan( aFuncList, { | x | upper( x[ 1 ] ) == cThisFunc } )

               if x > 0
                  bo_write( bo_handle, cThisLine + CRLF )

                  bo_write( bo_handle, '*+' + CRLF )

                  nY        := len( aFuncList[ x, 2 ] )
                  cLastProg := '________'
                  z         := 0
                  for y := 1 to nY
                     if lStatic         // is the function static?

                        // Here, we are scoping the search. If this is
                        // a static function, then there could be several
                        // of the function by the same name, so this
                        // routine figures out if the function is static
                        // and then eliminates impossible calls from other
                        // modules.

                        // if these match, then the call belongs to this
                        // static function in this module
                        if aFileList[ v ] == aFuncList[ x, 2, y, 2 ]
                           cThisProg := ' ( ' + ;
                                        pad( lower( aFuncList[ x, 2, y, 2 ] ), 12 ) + ;
                                        ' ) '

                           if cThisProg <> cLastProg
                              cProg := cThisProg
                           else
                              cProg := space( 18 )
                           endif
                           cOutput := if( ++ z == 1, 'Called from', space( 11 ) ) + ;
                                          cProg + ;
                                          str( aFuncList[ x, 2, y, 3 ], 3 ) + ' - ' + ;
                                          lower( aFuncList[ x, 2, y, 1 ] )
                           cLastProg := cThisProg
                           show_out( cOutput )
                           bo_write( bo_handle, '*+    ' + cOutput + CRLF )
                        endif

                     else

                        // So if we are here, the function was not static.
                        // include ALL calls.

                        cThisProg := ' ( ' + ;
                                     pad( lower( aFuncList[ x, 2, y, 2 ] ), 12 ) + ;
                                     ' ) '

                        if cThisProg <> cLastProg
                           cProg := cThisProg
                        else
                           cProg := space( 18 )
                        endif
                        cOutput := if( y == 1, 'Called from', space( 11 ) ) + ;
                                       cProg + ;
                                       str( aFuncList[ x, 2, y, 3 ], 3 ) + ' - ' + ;
                                       lower( aFuncList[ x, 2, y, 1 ] )
                        cLastProg := cThisProg
                        show_out( cOutput )
                        bo_write( bo_handle, '*+    ' + cOutput + CRLF )
                     endif
                  next
                  loop
               endif
            endcase
         endif
         bo_write( bo_handle, cThisLine + CRLF )
      enddo

      bclose( bi_handle )
      bo_close( bo_handle )

      if lTimeDate  // From CLICK.INI
         setfdati( cOutFile, filedate( cThisFile ), filetime( cThisFile ) )
      endif

      ferase( cThisFile )
      frename( cOutFile, cThisFile )

   next
endif

@  4,  1 clear to 7, maxcol() - 1

if !empty( cSrcOut )

   // This creates the text file in the output directory which contains
   // the entire function reference for every module.

   // It dumps the multidimensional array to a text file in a pretty format.

   centertext( 'Current File => ' + cOutDir + '\' + cSrcOut, 4 )

   ferase( cOutDir + '\' + cSrcOut )
   bo_Handle := bo_init( cOutDir + '\' + cSrcOut )
   bo_open( bo_Handle )

   bo_write( bo_handle, '*+' + replicate( cHeadDiv, 68 ) + CRLF )
   bo_write( bo_handle, '*+' + CRLF )
   bo_write( bo_handle, '*+    Created by Click! on ' + nicedate( date() ) + ' at ' + am_pm( time() ) + CRLF )
   bo_write( bo_handle, '*+' + CRLF )
   bo_write( bo_handle, '*+' + replicate( cHeadDiv, 68 ) + CRLF + CRLF )

   show_out( 'Sorting Master Function List' )
   aFuncs := asort( aFuncs,,, { | x, y | upper( x[ 1 ] ) < upper( y[ 1 ] ) } )

   show_out( 'Sorting Sub Function List' )
   nX := len( aFuncs )
   for x := 1 to nX
      show_out( aFuncs[ x, 1 ] )
      bo_write( bo_handle, aFuncs[ x, 1 ] + CRLF + CRLF )
      aeval( aFuncs[ x, 2 ], { | x | bo_write( bo_handle, '  ' + x + CRLF ) } )
      bo_write( bo_handle, CRLF )
   next
   bo_close( bo_handle )
endif

if !empty( cFncOut )

   // This creates the text file in the output directory which contains
   // the function to function reference for every module.

   // It dumps the multidimensional array to a text file in a pretty format.

   @  4,  1 clear to 4, maxcol() - 1
   centertext( 'Current File => ' + cOutDir + '\' + cFncOut, 4 )

   ferase( cOutDir + '\' + cFncOut )
   bo_Handle := bo_init( cOutDir + '\' + cFncOut )
   bo_open( bo_Handle )

   bo_write( bo_handle, '*+' + replicate( cHeadDiv, 68 ) + CRLF )
   bo_write( bo_handle, '*+' + CRLF )
   bo_write( bo_handle, '*+    Created by Click! on ' + nicedate( date() ) + ' at ' + am_pm( time() ) + CRLF )
   bo_write( bo_handle, '*+' + CRLF )
   bo_write( bo_handle, '*+' + replicate( cHeadDiv, 68 ) + CRLF )

   show_out( 'Sorting Called Function List' )
   aFuncList := asort( aFuncList,,, { | x, y | upper( x[ 1 ] ) < upper( y[ 1 ] ) } )

   nX := len( aFuncList )
   for x := 1 to nX
      cLookFor := lower( aFunclist[ x, 1 ] )
      if cLookFor == 'if'
         loop
      endif
      cOutput  := pad( cLookFor + '()', 15 )
      cFoundIn := findfunc( ' ' + aFunclist[ x, 1 ] + '()' )
      cLookFor += ' '
      if empty( cFoundIn )
         // Not found in the internal function array
         lGotIt := .f.
         // is it in the CLICK.DBF?
         if click->( dbseek( cLookFor ) )
            // if we weren't passed a .LNK file, we have no LIB list
            if lNoLibList
               // show them all
               do while cLookFor $ click->fnct
                  if len( cOutPut ) == 15
                     cOutput += ' in ' + trim( click->srce ) + CRLF
                  else
                     cOutput += space( 15 ) + ' or ' + trim( click->srce ) + CRLF
                  endif
                  show_in( space( 19 ) + click->srce )
                  lGotIt := .t.
                  click->( dbskip( 1 ) )
               enddo
            else
               // aha! we do have a lib list

               // first, find all the matches in the lib list.

               aLib     := {}
               aHit     := {}
               nMinPntr := 9999999999
               do while cLookFor $ click->fnct
                  if ( nPointer := ascan( aLibList, { | aParm | aParm $ trim( click->srce ) } ) ) > 0
                     aadd( aHit, nPointer )
                     aadd( aLib, aLibList[ nPointer ] )
                     nMinPntr := min( nMinPntr, nPointer )
                  endif
                  click->( dbskip( 1 ) )
               enddo

               // then, figure out which one is the first one in the current path.

               if len( aHit ) > 0
                  nPointer := ascan( aHit, nMinPntr )
                  cOutput  += ' in ' + fileinpath( aLib[ nPointer ], 'LIB' ) + CRLF
                  show_in( space( 19 ) + aLib[ nPointer ] )
                  lGotIt := .t.
               endif

            endif
         endif

         // never found a match???

         if !lGotIt
            cOutput += ' <unresolved function>'
            show_in( cOutput )
            cOutput += CRLF
         endif

      else
         cOutput += ' in ' + lower( cFoundIn )
         show_in( cOutput )
         cOutput += CRLF
      endif

      bo_write( bo_Handle, CRLF + cOutput + CRLF )
      cLastProg := '________'

      aFuncList[ x, 2 ] := asort( aFuncList[ x, 2 ],,, { | x, y | upper( x[ 2 ] + x[ 1 ] ) < upper( y[ 2 ] + y[ 1 ] ) } )
      nY                := len( aFuncList[ x, 2 ] )
      for y := 1 to nY
         cThisProg := ' ( ' + ;
                      pad( lower( aFuncList[ x, 2, y, 2 ] ), 12 ) + ;
                      ' ) '

         if cThisProg <> cLastProg
            cProg := cThisProg
         else
            cProg := space( 18 )
         endif
         cOutput := if( y == 1, '  Called from', space( 13 ) ) + ;
                        cProg + ;
                        str( aFuncList[ x, 2, y, 3 ], 3 ) + ' - ' + ;
                        lower( aFuncList[ x, 2, y, 1 ] )

         cLastProg := cThisProg
         show_out( cOutput )
         bo_write( bo_handle, cOutput + CRLF )
      next
   next
   bo_close( bo_Handle )
endif

if !empty( cTblOut )

   centertext( 'Current File => ' + cOutDir + '\' + cTblOut, 4 )

   ferase( cOutDir + '\' + cTBLOut )
   bo_Handle := bo_init( cOutDir + '\' + cTblOut )
   bo_open( bo_Handle )

   bo_write( bo_handle, '*+' + replicate( cHeadDiv, 68 ) + CRLF )
   bo_write( bo_handle, '*+' + CRLF )
   bo_write( bo_handle, '*+    Created by Click! on ' + nicedate( date() ) + ' at ' + am_pm( time() ) + CRLF )
   bo_write( bo_handle, '*+' + CRLF )
   bo_write( bo_handle, '*+' + replicate( cHeadDiv, 68 ) + CRLF )
   bo_write( bo_handle, CRLF )

   for v := 1 to nV

      nPointer1 := ascan( aTable, { | x | x[ 1 ] == aFileList[ v ] } )
      nPointer2 := ascan( aIndex, { | x | x[ 1 ] == aFileList[ v ] } )

      if nPointer1 > 0 .or. nPointer2 > 0

         bo_write( bo_handle, aFileList[ v ] + CRLF + CRLF )
         show_in( aFileList[ v ] )

         if nPointer1 > 0
            nY := len( aTable[ nPointer1, 2 ] )
            if nY > 0
               for y := 1 to nY
                  if y == 1
                     bo_write( bo_handle, '   Tables: ' + aTable[ nPointer1, 2, y, 2 ] + CRLF )
                  else
                     bo_write( bo_handle, '           ' + aTable[ nPointer1, 2, y, 2 ] + CRLF )
                  endif
                  show_out( aTable[ nPointer1, 2, y, 2 ] )
               next
               bo_write( bo_handle, CRLF )
            endif
         endif

         if nPointer2 > 0
            nY := len( aIndex[ nPointer2, 2 ] )
            if lTblAdd .and. nY > 0
               for y := 1 to nY
                  if y == 1
                     bo_write( bo_handle, '  Indexes: ' + aIndex[ nPointer2, 2, y, 2 ] + CRLF )
                  else
                     bo_write( bo_handle, '           ' + aIndex[ nPointer2, 2, y, 2 ] + CRLF )
                  endif
                  show_out( aIndex[ nPointer2, 2, y, 2 ] )
               next
               bo_write( bo_handle, CRLF )
            endif
         endif

      endif

   next

   bo_close( bo_Handle )

endif

@  4,  1 clear to 4, maxcol() - 1
@  6,  1 clear to 6, maxcol() - 1

return

*+
*+
*+    Static Function findfunc()
*+
*+    Called from ( functrak.prg )   1 - procedure func_text()
*+
*+
*+
static function findfunc( cThisFunc )

local x
local nX
local y
local nY
local lRetVal  := ''
local nFuncLen
local cLookIn

// This function finds a function reference in the master array.

cThisFunc := upper( cThisFunc )
nFuncLen  := len( cThisFunc ) + 2

nX := len( aFuncs )
for x := 1 to nX
   nY := len( aFuncs[ x, 2 ] )
   for y := 1 to nY
      cLookIn := right( upper( aFuncs[ x, 2, y ] ), nFuncLen )
      if cThisFunc $ cLookIn
         lRetVal := aFuncs[ x, 1 ]
      endif
   next
next

return lRetVal

*+
*+
*+    Static Function SubArrySrch()
*+
*+    Called from ( functrak.prg )   2 - procedure func_call()
*+
*+
*+
static function SubArrySrch( aFuncs, aLine )

local x
local y
local lRetVal := .f.

begin sequence
   for y := 1 to len( aLine )
      for x := 1 to len( aFuncs )
         if aFuncs[ x ] == upper( aLine[ y ] )
            lRetVal := .t.
            break
         endif
      next
   next
end sequence

return lRetVal

*+ EOF: FUNCTRAK.PRG
