*+
*+
*+    Source Module => D:\SRC\CLICK\OBUFWRIT.PRG
*+
*+    Click! is a Clipper/Xbase++ source code reformatter.
*+    
*+    Copyright(C) 1996-1999 by Phil Barnett.
*+       
*+    This program is free software; you can redistribute it and/or modify it
*+    under the terms of the GNU General Public License as published by the
*+    Free Software Foundation; either version 2 of the License, or (at your
*+    option) any later version.
*+    
*+    This program is distributed in the hope that it will be useful, but
*+    WITHOUT ANY WARRANTY; without even the implied warranty of
*+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*+    General Public License for more details.
*+    
*+    You should have received a copy of the GNU General Public License along
*+    with this program; if not, write to the Free Software Foundation, Inc.,
*+    675 Mass Ave, Cambridge, MA 02139, USA.
*+    
*+    You can contact me at:
*+    
*+    Phil Barnett
*+    Box 944
*+    Plymouth, Florida  32768
*+    
*+    or
*+    
*+    philb@iag.net
*+
*+    Functions: Function bo_init()
*+               Function bo_open()
*+               Procedure bo_write()
*+               Procedure bo_writeNoDupe()
*+               Procedure bo_close()
*+
*+    Reformatted by Click! 2.03 on Jan-26-1999 at 12:35 am
*+
*+

#include "FILEIO.CH"
#include "COMMON.CH"

#define cFileName oObjData[ 1 ]
#define nAccMode oObjData[ 2 ]
#define cOutBuffer oObjData[ 3 ]
#define cOutBufLen oObjData[ 4 ]
#define nHandle oObjData[ 5 ]
#define lLastWasEmpty oObjData[ 6 ]
#define lRemoveDups oObjData[ 7 ]

#define BUFFLEN 2560

#define CRLF chr( 13 ) + chr( 10 )

// This is a buffered write (output) routine that keeps the disk from
// thrashing on a bunch of little writes. This speeds up output
// dramatically.

*+
*+
*+    Function bo_init()
*+
*+    Called from ( click.prg    )   1 - procedure click()
*+                                   1 - static procedure thealigner()
*+                ( declbust.prg )   1 - procedure declbust()
*+                ( functrak.prg )   4 - procedure func_text()
*+
*+
*+
function bo_init( xFileName, xAccMode )

local cFullPath := if( file( 'CLICK.INI' ), 'CLICK', RootName( ft_origin() ) ) + '.INI'

default xAccMode to FO_WRITE

return { xFileName, ;
         xAccMode, ;
         '', ;
         0, ;
         - 1, ;
         .f., ;
         ProfileString( cFullPath, 'CLICK', 'REMOVE_DUPLICATE_EMPTY_LINES', 'YES' ) == 'YES' ;
         }

*+
*+
*+    Function bo_open()
*+
*+    Called from ( click.prg    )   1 - procedure click()
*+                                   1 - static procedure thealigner()
*+                ( declbust.prg )   1 - procedure declbust()
*+                ( functrak.prg )   4 - procedure func_text()
*+
*+
*+
function bo_open( oObjData )

begin sequence

   if !file( cFileName )
      nHandle := fcreate( cFileName, FC_NORMAL )
      if nHandle == - 1
         break
      endif
      fclose( nHandle )
   endif

   nHandle := fopen( cFileName, nAccMode )

   fseek( nHandle, 0, FS_END )

end sequence

return nHandle # - 1

*+
*+
*+    Procedure bo_write()
*+
*+    Called from ( click.prg    )  22 - procedure click()
*+                                   2 - static function breadpart()
*+                ( declbust.prg )  15 - procedure declbust()
*+                ( functrak.prg )  42 - procedure func_text()
*+
*+
*+
procedure bo_write( oObjData, cSomeText )

cOutBufLen += len( cSomeText )

cOutBuffer += cSomeText

if cOutBufLen > BUFFLEN
   fwrite( nHandle, cOutBuffer )
   cOutBuffer := ''
   cOutBufLen := 0
endif

return

*+
*+
*+    Procedure bo_writeNoDupe()
*+
*+    Called from ( click.prg    )  17 - static procedure thealigner()
*+
*+
*+
procedure bo_writeNoDupe( oObjData, cSomeText )

if !lRemoveDups .or. cSomeText <> CRLF .or. ( cSomeText == CRLF .and. !lLastWasEmpty )

   cOutBufLen += len( cSomeText )

   cOutBuffer += cSomeText

   if cOutBufLen > BUFFLEN
      fwrite( nHandle, cOutBuffer )
      cOutBuffer := ''
      cOutBufLen := 0
   endif

endif

lLastWasEmpty := ( cSomeText == CRLF )

return

*+
*+
*+    Procedure bo_close()
*+
*+    Called from ( click.prg    )   1 - procedure click()
*+                                   1 - static procedure thealigner()
*+                ( declbust.prg )   1 - procedure declbust()
*+                ( functrak.prg )   4 - procedure func_text()
*+
*+
*+
procedure bo_close( oObjData )

fwrite( nHandle, cOutBuffer )

fclose( nHandle )

return

*+ EOF: OBUFWRIT.PRG
