*+
*+
*+    Source Module => D:\SRC\CLICK\QSORT.PRG
*+
*+    Click! is a Clipper/Xbase++ source code reformatter.
*+    
*+    Copyright(C) 1996-1999 by Phil Barnett.
*+       
*+    This program is free software; you can redistribute it and/or modify it
*+    under the terms of the GNU General Public License as published by the
*+    Free Software Foundation; either version 2 of the License, or (at your
*+    option) any later version.
*+    
*+    This program is distributed in the hope that it will be useful, but
*+    WITHOUT ANY WARRANTY; without even the implied warranty of
*+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*+    General Public License for more details.
*+    
*+    You should have received a copy of the GNU General Public License along
*+    with this program; if not, write to the Free Software Foundation, Inc.,
*+    675 Mass Ave, Cambridge, MA 02139, USA.
*+    
*+    You can contact me at:
*+    
*+    Phil Barnett
*+    Box 944
*+    Plymouth, Florida  32768
*+    
*+    or
*+    
*+    philb@iag.net
*+
*+    Functions: Function QuickSort()
*+               Procedure bSort()
*+               Procedure qSort()
*+
*+    Reformatted by Click! 2.03 on Jan-26-1999 at 12:36 am
*+
*+

/*
 #: 150 S0/CompuServe Mail
    28-Nov-93 14:46 EST
Sb: Is there a fast ASORT()
Fm: Trevor Dunsford [72074,1263]

Raymond,

The quickSort function just sets up the call to the bsort/qsort
functions. bsort() will handle evaluation of codeblocks and qsort() is
optimized to handle one dimensional arrays.  The codeblock for bsort is
slightly different than asort, instead of the usual { |x,y| x[1]<y[1] },
it is just { |x| x[1] } because of the way it handles comparison.  I
believe, that with a few simple modifications, you could make bsort use
the asort codeblocks...

trev
*/

#include "COMMON.CH"

//
// QuickSort(<aList>,[<bBlock>]) --> aList
//   * <bBlock> format is { |<var>| <var>[<offset>] }
//

*+
*+
*+    Function QuickSort()
*+
*+    Called from ( cmd_list.prg )   3 - function init_list()
*+
*+
*+
function QuickSort( aList, bBlock )

if len( aList ) > 0
   if isblock( bBlock )
      bsort( @aList, 1, len( aList ), @bBlock )
   else
      qsort( @aList, 1, len( aList ) )
   endif
endif

return aList

*+
*+
*+    Procedure bSort()
*+
*+    Called from ( qsort.prg    )   1 - function quicksort()
*+                                   2 - procedure bsort()
*+
*+
*+
procedure bSort( a, l, r, b )

local y
local i := l
local j := r
local x := eval( b, a[ int( ( l + r ) / 2 ) ] )

while eval( b, a[ i ] ) < x
   i ++
end

while x < eval( b, a[ j ] )
   j --
end

if i <= j
   y      := a[ i ]
   a[ i ] := a[ j ]
   a[ j ] := y
   i ++
   j --
endif

do while i < j

   while eval( b, a[ i ] ) < x
      i ++
   end

   while x < eval( b, a[ j ] )
      j --
   end

   if i <= j
      y      := a[ i ]
      a[ i ] := a[ j ]
      a[ j ] := y
      i ++
      j --
   endif

enddo

if l < j
   bSort( @a, l, j, @b )
endif

if i < r
   bSort( @a, i, r, @b )
endif

return

*+
*+
*+    Procedure qSort()
*+
*+    Called from ( qsort.prg    )   1 - function quicksort()
*+                                   2 - procedure qsort()
*+
*+
*+
procedure qSort( a, l, r )

local y
local i := l
local j := r
local x := a[ int( ( l + r ) / 2 ) ]

while a[ i ] < x
   i ++
end

while x < a[ j ]
   j --
end

if i <= j
   y      := a[ i ]
   a[ i ] := a[ j ]
   a[ j ] := y
   i ++
   j --
endif

do while i < j

   while a[ i ] < x
      i ++
   end

   while x < a[ j ]
      j --
   end

   if i <= j
      y      := a[ i ]
      a[ i ] := a[ j ]
      a[ j ] := y
      i ++
      j --
   endif

enddo

if l < j
   qSort( @a, l, j )
endif

if i < r
   qSort( @a, i, r )
endif

return

*+ EOF: QSORT.PRG
