*+
*+
*+    Source Module => D:\SRC\CLICK\READLIST.PRG
*+
*+    Click! is a Clipper/Xbase++ source code reformatter.
*+    
*+    Copyright(C) 1996-1999 by Phil Barnett.
*+       
*+    This program is free software; you can redistribute it and/or modify it
*+    under the terms of the GNU General Public License as published by the
*+    Free Software Foundation; either version 2 of the License, or (at your
*+    option) any later version.
*+    
*+    This program is distributed in the hope that it will be useful, but
*+    WITHOUT ANY WARRANTY; without even the implied warranty of
*+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*+    General Public License for more details.
*+    
*+    You should have received a copy of the GNU General Public License along
*+    with this program; if not, write to the Free Software Foundation, Inc.,
*+    675 Mass Ave, Cambridge, MA 02139, USA.
*+    
*+    You can contact me at:
*+    
*+    Phil Barnett
*+    Box 944
*+    Plymouth, Florida  32768
*+    
*+    or
*+    
*+    philb@iag.net
*+
*+    Functions: Function readlist()
*+
*+    Reformatted by Click! 2.03 on Jan-26-1999 at 12:36 am
*+
*+

#include "COMMON.CH"

*+
*+
*+    Function readlist()
*+
*+    Called from ( click.prg    )   1 - procedure click()
*+                ( cmd_list.prg )   3 - function init_list()
*+                ( libread.prg  )   1 - procedure libread()
*+
*+
*+
function readlist( inifile, category )

// This reads in a list from disk from an .INI file section and returns
// it as an array. If you pass in a @ as the category, it reads the
// entire file into an array. This is buffered for speed and assumes
// that the .INI text file is less than 32k

local retarry   := {}
local cThisLine
local ini_data  := memoread( inifile )
local nPointer
local CRLF      := chr( 13 ) + chr( 10 )
local lCatFound

begin sequence

   category := '[' + upper( alltrim( category ) ) + ']'

   lCatFound := category == '[@]'

   if !lCatFound
      nPointer := at( category, ini_data )
      if nPointer > 0
         ini_data  := substr( ini_data, nPointer )
         nPointer  := at( CRLF, ini_data )
         cThisLine := left( ini_data, nPointer - 1 )
         ini_data  := substr( ini_data, nPointer + 2 )
      else
         break
      endif
   endif

   do while len( ini_data ) > 0

      nPointer := at( CRLF, ini_data )

      if nPointer > 0
         cThisLine := left( ini_data, nPointer - 1 )
         ini_data  := substr( ini_data, nPointer + 2 )
      else
         cThisLine := ini_data
         ini_data  := ''
      endif

      if empty( cThisLine ) .or. left( ltrim( cThisLine ), 2 ) == '//'
         loop
      endif

      if left( cThisLine, 1 ) == '['
         exit
      else
         aadd( retarry, cThisLine )
      endif

   enddo

end sequence

return retarry

*+ EOF: READLIST.PRG
